#!/usr/bin/perl
#
# SCoRE - Search a Corpus for Regular Expressions
#
# Usage: (called by web server)
#
# Copies temporary HTML search results file to specified file name
#
# (c) Matthew Purver, King's College London, 2001
#
# $Log: save_file.cgi,v $
# Revision 1.1  2001/11/09 12:31:00  purver
# Initial revision
#

# import subroutines
use SCoRE qw( $saveDir $saveFile $tempFile $fileExt );
use CGI qw( param header );

# start display
print header();

# get user parameters
$fileName = param( 'fileName' );
$fileDesc = param( 'fileDesc' );
$str = param( 'string' );

# process parameters for HTML use
$str =~ s/</&lt;/g;
$str =~ s/>/&gt;/g;

# check file name has been entered
if ( defined( $fileName ) and ( $fileName ne '' ) ) {

    # add extension if necessary
    $fileName .= $fileExt unless ( $fileName =~ /$fileExt$/ );

    # check for existence and copy file
    if ( -f "$saveDir/$fileName" ) {
	print "Error: $fileName already exists - choose another name.\n";
    }
    else {
	# copy the file itself
	print `cp $tempFile $saveDir/$fileName`;

	# add entry to HTML list file
	print `cp $saveFile _$saveFile`;
	open( IN, "< _$saveFile" ) or die "Couldn\'t open _$saveFile\n";
	open( OUT, "> $saveFile" ) or die "Couldn\'t open $saveFile\n";
	while ( <IN> ) {
	    print OUT;
	    if ( /<!--\s+Insert/ ) {
		print OUT "  <tr><td><a href=\"$saveDir/$fileName\">$str</a></td>" .
		    "<td>  ($fileDesc)</td></tr>\n";
	    }
	}
	close IN;
	close OUT;

	# tell user
	print "<br><br><H2>Saved as $fileName.</H2>";
	print "<br><br>Will now be available under Saved Searches.";
	print "<br><br>(You might have to press the \"Reload\" button on your browser to see it)";
    }
}
else {
    print "<br><br>Error: must specify a file name.";
}

# finish
print "<br><br>Press BACK button on browser to return to Search Results.";
